=== debian/changelog ===
vcmi (1.6.8) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 25 Apr 2025 12:00:00 +0200

vcmi (1.6.7) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 28 Feb 2025 12:00:00 +0200

vcmi (1.6.6) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 21 Feb 2025 12:00:00 +0200

vcmi (1.6.5) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Mon, 3 Feb 2025 12:00:00 +0200

vcmi (1.6.4) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 31 Jan 2025 12:00:00 +0200

vcmi (1.6.3) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 10 Jan 2025 12:00:00 +0200

vcmi (1.6.2) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 3 Jan 2025 12:00:00 +0200

vcmi (1.6.1) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 27 Dec 2024 12:00:00 +0200

vcmi (1.6.0) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 20 Dec 2024 12:00:00 +0200

vcmi (1.5.7) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Mon, 26 Aug 2024 12:00:00 +0200

vcmi (1.5.6) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Sun, 4 Aug 2024 12:00:00 +0200

vcmi (1.5.5) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Wed, 17 Jul 2024 12:00:00 +0200

vcmi (1.5.4) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 12 Jul 2024 12:00:00 +0200

vcmi (1.5.3) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 21 Jun 2024 12:00:00 +0200

vcmi (1.5.2) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 31 May 2024 12:00:00 +0200

vcmi (1.5.1) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 17 May 2024 12:00:00 +0200

vcmi (1.5.0) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 10 May 2024 12:00:00 +0200

vcmi (1.4.5) jammy; urgency=medium

  * New upstream release

  -- Ivan Savenko <saven.ivan@gmail.com>  Tue, 23 Jan 2024 12:00:00 +0200

vcmi (1.4.4) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Sat, 20 Jan 2024 12:00:00 +0200

vcmi (1.4.3) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 19 Jan 2024 12:00:00 +0200

vcmi (1.4.2) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Mon, 25 Dec 2023 16:00:00 +0200

vcmi (1.4.1) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Tue, 12 Dec 2023 16:00:00 +0200

vcmi (1.4.0) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 8 Dec 2023 16:00:00 +0200

vcmi (1.3.2) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 15 Sep 2023 16:00:00 +0200

vcmi (1.3.1) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 18 Aug 2023 16:00:00 +0200

vcmi (1.3.0) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 04 Aug 2023 16:00:00 +0200

vcmi (1.2.1) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 28 Apr 2023 16:00:00 +0200

vcmi (1.2.0) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 14 Apr 2023 16:00:00 +0200

vcmi (1.1.1) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 03 Feb 2023 12:00:00 +0200

vcmi (1.1.0) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 23 Dec 2022 12:00:00 +0200
 

vcmi (1.0.0) jammy; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Sun, 13 Nov 2022 17:28:31 +0200

vcmi (0.99) trusty; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Tue, 01 Nov 2016 20:41:53 +0200

vcmi (0.98.1) trusty; urgency=medium

  * Development version 0.98b

 -- Ivan Savenko <saven.ivan@gmail.com>  Sat, 02 May 2015 09:00:52 +0300

vcmi (0.98) trusty; urgency=medium

  * New upstream release
  * Now built with SDL2

 -- Ivan Savenko <saven.ivan@gmail.com>  Wed, 01 Apr 2015 22:57:38 +0200

vcmi (0.97) trusty; urgency=medium

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Tue, 11 Nov 2014 22:57:48 +0200

vcmi (0.96) trusty; urgency=low

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Tue, 01 Jul 2014 20:57:29 +0300

vcmi (0.95) precise; urgency=low

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Wed, 26 Feb 2014 16:05:00 +0200

vcmi (0.94) precise; urgency=low

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Tue, 01 Oct 2013 20:50:01 +0300

vcmi (0.93) precise; urgency=low

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Sat, 01 Jun 2013 02:10:12 +0300

vcmi (0.92) precise; urgency=low

  * New upstream release

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 01 Mar 2013 10:28:08 +0200

vcmi (0.91) unstable; urgency=low

  * New upstream release
  * Build system is now CMake

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 01 Feb 2013 10:49:40 +0200

vcmi (0.90) unstable; urgency=low

  * New upstream release
  * Removed boost iostream dependency

 -- Ivan Savenko <saven.ivan@gmail.com>  Mon, 1 Oct 2012 15:20:30 +0200

vcmi (0.89) unstable; urgency=low

  * New upstream release
  * Removed unnecessary dependencies

 -- Ivan Savenko <saven.ivan@gmail.com>  Fri, 1 June 2012 20:06:50 +0200


